      subroutine minimize(ffit,x,iretcode,nfun)
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'sizesclu.dat'

      parameter (liv=60,lv=(77+maxvar*(maxvar+17)/2)) 
*********************************************************************
* OPTIMIZE sets up SUMSL or DFP and provides a simple interface for *
* the calling subprogram.                                           *     
* when d(i)=1.0, then v(35) is the length of the initial step,      *     
* calculated in the usual pythagorean way.                          *     
* absolute convergence occurs when the function is within v(31) of  *     
* zero. unless you know the minimum value in advance, abs convg     *     
* is probably not useful.                                           *     
* relative convergence is when the model predicts that the function *   
* will decrease by less than v(32)*abs(fun).                        *   
*********************************************************************
      include 'COMMON.IOUNITS'
      dimension iv(liv)                                               
      double precision minval,x(maxvar),d(maxvar),v(1:lv)
      external func,gradient,fdum
      double precision ffit
      integer iprint /0/,iprint1 /0/

      nvar=4

c      print *,"maxvar",maxvar," liv",liv," lv",lv
      call deflt(2,iv,liv,lv,v)
* 12 means fresh start, dont call deflt                                 
      iv(1)=12                                                          
* max num of fun calls                                                  
      iv(17)=1000
* max num of iterations                                                 
      iv(18)=1000
* controls output                                                       
      iv(19)=iprint1
* selects output unit                                                   
      iv(21)=0
c      iv(21)=iout
* 1 means to print out result                                           
      iv(22)=iprint
* 1 means to print out summary stats                                    
      iv(23)=iprint
* 1 means to print initial x and d                                      
      iv(24)=iprint
* min val for v(radfac) default is 0.1                                  
      v(24)=0.1D0                                                       
* max val for v(radfac) default is 4.0                                  
      v(25)=2.0D0                                                       
c     v(25)=4.0D0                                                       
* check false conv if (act fnctn decrease) .lt. v(26)*(exp decrease)    
* the sumsl default is 0.1                                              
      v(26)=0.1D0
* false conv if (act fnctn decrease) .lt. v(34)                         
* the sumsl default is 100*machep                                       
      v(34)=v(34)/100.0D0                                               
* absolute convergence                                                  
      if (tolf.eq.0.0D0) tolf=1.0D-4
      v(31)=1.0d-8
* relative convergence                                                  
      if (rtolf.eq.0.0D0) rtolf=1.0D-4
      v(32)=1.0d-8
* controls initial step size                                            
       v(35)=1.0D-1                                                    
* large vals of d correspond to small components of step                
      do i=1,4
        d(i)=1.0D-1
      enddo
      call sumsl(nvar,d,x,func,gradient,iv,liv,lv,v,idum,rdum,fdum)
c      print *,"finished sumsl"
      ffit=v(10)
c      print *, "fit",v(10)
      iretcode=iv(1)
      nfun=iv(6)

      return  
      end  
c------------------------------------------------------------------------
      subroutine func(n,x,nf,f,uiparm,urparm,ufparm)  
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'sizesclu.dat'
      include 'COMMON.IOUNITS'
      double precision ufparm
      external ufparm                                                   
      integer uiparm(1)                                                 
      real*8 urparm(1)                                                    
      dimension x(maxvar)
      nfl=nf
      icg=mod(nf,2)+1
      f=gaussdiff(x)
      return                                                            
      end                                                               
************************************************************************
      subroutine gradient(n,x,nf,g,uiparm,urparm,ufparm)
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'sizesclu.dat'
      include 'COMMON.IOUNITS'
      external ufparm
      integer uiparm(1),k
      double precision urparm(1)
      dimension x(maxvar),g(maxvar)
cbad      icg=mod(nf,2)+1
      icg=1
cd      print *,'grad_dc ',nf,nfl,nf-nfl+1,icg
      if (nf-nfl+1) 20,30,40
   20 call func(n,x,nf,f,uiparm,urparm,ufparm)
cd      print *,20
      if (nf.eq.0) return
      goto 40
   30 continue
cd      print *,30
C Evaluate the derivatives of virtual bond lengths and SC vectors in variables.
C
   40 call gaussdiffder(x,g)

      return
      end
************************************************************************
      double precision function fdum()
      fdum=0.0D0
      return
      end
c------------------------------------------------------------------------------
      logical function stopx(nf)
      integer nf
      stopx=.false.
      return
      end
